# -*- coding: utf-8 -*-
# algorithm allocating cpu time to cores

import procinfo
import config

class AllocationError(Exception):
	
	def __init__(self, msg):
		Exception.__init__(self, msg)

def allocate(vcores):
	'''allocate virtual cores to real cores'''
	'''number of vcores is at most number of physical cores'''
	info = procinfo.getinfo()
	ps   = info['procs']
	if len(vcores) != len(ps.keys()):
		raise AllocationError('Invalid number of vcores.')
	n = len(vcores)
	# we now allocate every vcore to physical core
	allocs = []
	for i in xrange(n):
		proc = ps[i]
		vcore = vcores[i]
		if proc['speed'] < vcore:
			raise AllocationError('Allocation is impossible.')
		allocs.append( (i, vcore) )
	return allocs
