# -*- coding: utf-8 -*-
# configuration stuff

import sys
import procinfo
import re
import ConfigParser

class ConfigError(Exception):
	def __init__(self, msg):
		Exception.__init__(self, msg)

def mapstring(f, s):
	return map(f, s.split())

def readconfig():
	global allow_throttling
	global allow_cpufreq
	global vcores
	
	procs = procinfo.getinfo()['procs']
	config = ConfigParser.RawConfigParser()
	config.read('config')
	
	try:
		allow_throttling = config.getboolean('main', 'allow_throttling')
		allow_cpufreq    = config.getboolean('main', 'allow_cpufreq')
		vcores           = config.get('main', 'vcores')
		vcores = mapstring(float, vcores)
	except ValueError, e:
		raise ConfigError(e)
	except ConfigParser.NoSectionError:
		raise ConfigError('No main section')
	except ConfigParser.NoOptionError, e:
		raise ConfigError(e)
