# -*- coding: utf-8 -*-
# gets information on cpus, cores, etc.

def processors():
	'''gets processors info - list of assoc maps (directly from cpuinfo)'''
	f = open('/proc/cpuinfo', 'r')
	lines = f.readlines()
	f.close()
	procs = []
	proc = {}
	for line in lines:
		line = line.strip()
		if not line:
			procs.append(proc)
			proc = {}
			continue
		name, value = line.split(':')
		name, value = name.strip(), value.strip()
		proc[name] = value
	return procs

def adv_processors(ps = None):
	'''gets advanced info on cores - mapping (log. proc -> info)'''
	if not ps:
		ps = processors()
	infos = {}
	for p in ps:
		info = {}
		info['speed'] = float(p['cpu MHz'])
		# info['bogomips'] = float(p['bogomips'])
		info['name'] = p['model name']
		info['physical'] = int(p.get('physical id', 0))
		info['cid'] = int(p.get('core id', 0))
		infos[int(p['processor'])] = info
	return infos

def getinfo():
	'''get global computing info - [speed] -> total speed, [maxspeed] -> fastest core, [procs] -> proc. info '''
	procs = adv_processors()
	info = {}
	info['procs'] = procs
	speeds = map(lambda x: procs[x]['speed'], procs)
	phys   = map(lambda x: procs[x]['physical'], procs)
	info['maxspeed'] = max(speeds)
	info['speed'] = sum(speeds)
	info['phys_num'] = len(set(phys))
	return info

if __name__ == '__main__':
	print getinfo()