#!/usr/bin/env python
# -*- coding: utf-8 -*-
# restricts all processess to specified cores
# use clean.py to restore normal behaviour

import sys
import cgroup
import rollback
import logging

logging.set(False)
argv = sys.argv

if len(argv) == 1:
	print >> sys.stderr, 'Wrong number of arguments!'
	sys.exit(1)

cores = map(lambda x: int(x), argv[1:])

try:
	csets = cgroup.Cpusets()
	csets.clean_cgroup()
	mems = csets.get_mems()
	csets.create_group('all')
	csets.assign_cpus(cores, 'all')
	csets.assign_mems(mems, 'all')
	csets.migrate_tasks([], ['all'])
finally:
	rollback.rollback()
