# -*- coding: utf-8 -*-
# runs application in sandbox
# more precisely:
# it's using cgroups to assign as much CPU as possible to a given process
# we don't want ANY possible process to affect running this one

import rollback
import procinfo
import logging
import subprocess
import shlex
import os
from cgroup import Cpusets
import sys

argv = sys.argv

if len(argv) != 2:
	print 'Syntax: sandbox <shell-cmd>'
	sys.exit(1)

logging.set(False)   # do not log!

try:
	n = len(procinfo.getinfo()['procs'])  # number of processors
	c = Cpusets()
	c.clean_cgroup()
	rollback.register(c.clean_cgroup, [])
	c.create_group('this'); c.assign_cpus([n-1], 'this')  # last processor
	c.create_group('rest'); c.assign_cpus([0], 'rest')
	c.set_cpushare(2, 'rest')
	c.set_cpushare(10000000, 'this')
	c.migrate_tasks([], ['rest'])
	pid = os.getpid()  # our pid
	c.move_task(pid, 'this')
	args = shlex.split(argv[1])
	code = subprocess.call(args)
	sys.exit(code)
finally:
	rollback.rollback()
