# -*- coding: utf-8 -*-
# 2010
# Client program for distest framework
# Connects to a specified part, downloads a test and performs it

import socket
import time
import sys
import os
import platform
from runner import runtest
from comm import PORT, send_obj, recv_obj, Error
from pprint import pprint
from subprocess import Popen, PIPE

argv = sys.argv

def loop():
	'''Returns number of seconds to wait until next invocation'''
	try:
		s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		s.connect( (argv[1], PORT) )
		log = lambda msg: send_obj(s, ('log', msg) )
		out = lambda msg: send_obj(s, ('out', msg) )
		err = lambda msg: send_obj(s, ('err', msg) )
		finish = lambda: send_obj(s, None)
		test = recv_obj(s)
		log('Platform: %s' % platform.platform(terse=True))
		if test == None:
			print 'No more tests.'
			return 60
		print 'Received test...'
		pprint(test)
		try:
			output, errput = runtest(test)
		except Exception, e:
			log('exception: %s' % e)
			return 60
		else:
			out(output)
			err(errput)
			finish()
	finally:
		s.close()
		sys.stdout.flush()
	return 1

if __name__ == '__main__':
	if len(argv) != 2:
		print 'Syntax: python ./client.py <hostname>'
		sys.exit(1)
	if os.geteuid() != 0:
		print 'You should be root to run this client program.'
		sys.exit(1)
	sleeptime = 1
	while True:
		print 'Waiting %d seconds...' % sleeptime
		time.sleep(sleeptime)
		try:
			sleeptime = loop()
		except socket.error, err:
			print 'exception: %s (%d)' % (err[1], err[0])
			sleeptime = 60
