
#include <stdio.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <stdlib.h>
#include "common.h"

#define BUF 1024

char bufp[BUF];

void burst_packets(int s, struct sockaddr* sa) {
	int res;
	int i;
	for (i=0; i < 10; i++) {
		res = sendto(s, bufp, BUF, 0, sa, sizeof(struct sockaddr));
		if (res != BUF) {
			fprintf(stderr, "sendto() error!\n");
			exit(1);   /* this is an error! */
		}
	}
	#ifdef WITH_CPU
	LOOP();
	#endif
}

int main() {
	struct sockaddr_in sa;
	struct sockaddr* saddr;
	
	int s = socket(AF_INET, SOCK_DGRAM, 0);
	if (s < 0) {
		fprintf(stderr, "socket() error\n");
		return 1;
	}
	saddr = (struct sockaddr*)&sa;
	memset(&sa, 0, sizeof(sa));
	inet_pton(AF_INET, IPADDR, &(sa.sin_addr));
	sa.sin_family = AF_INET;
	sa.sin_port = htons(7654);
	
	printf("# sending packets to %s\n", IPADDR);
	
	timespan ts = MEASURE(burst_packets(s, saddr), 1.);
	
	if (close(s) != 0) {
		fprintf(stderr, "close() error\n");
		return 1;
	}
	
	#ifdef WITH_CPU
	char* name = "cpudper";
	#else
	char* name = "udper";
	#endif

	double cpu  = ts.cpu;
	double wall = ts.wall;
	double kups = ts.loops / ts.wall;
	
	printf("# wall: %.4lf, cpu: %.4lf, ratio: %.4lf\n", wall, cpu, wall / cpu);
	printf("%s=%.8lf\n", name, kups);
	
	return 0;
}